
var g_bridge;

var p_api = document.getElementById('api_contentText');
var p_config = document.getElementById('config_contentText');
var p_player = document.getElementById('player_contentText');

function setupWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) { return callback(WebViewJavascriptBridge); }
    if (window.WVJBCallbacks) { return window.WVJBCallbacks.push(callback); }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'https://__bridge_loaded__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function () { document.documentElement.removeChild(WVJBIframe) }, 0)
}

setupWebViewJavascriptBridge(function (bridge) {

    /* Initialize your app here */

    g_bridge = bridge

    bridge.callHandler('OMCSetup', { 'key': 'value' }, function responseCallback(responseData) {
        p_api.innerHTML = responseData
    })
})


const OMC_PORTAL_API = "OMCPortalAPI"
const OMC_PORTAL_CONFIG = "OMCPortalConfig"
const OMC_PLAYER = "OMCPlayer"


function OMCSDK_reqLocations() {
    var input = {
        method: "reqLocations"
    }

    p_api.innerHTML = "Loading";

    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {

        p_api.innerHTML = JSON.stringify(responseData)

        let firstLocation = responseData.result[0]
        let locationID = firstLocation.locationID

        var input = { plocation: locationID };

        g_bridge.callHandler(OMC_PORTAL_CONFIG, input, function responseCallback(responseData) {
            p_api.innerHTML = p_api.innerHTML + "<br/>" + "公参设置结果：" + JSON.stringify(responseData)
        })

    });
}

function OMCSDK_reqResolutions() {
    var input = {
        method: "reqResolutions"
    }

    p_api.innerHTML = "Loading";

    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_login() {
    var input = {
        method: "login",
        params: {
            user: "lgc8888",
            password: "123456"
        }
    }

    p_api.innerHTML = "正在登录";
    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_register() {
    var input = {
        method: "register",
        params: {
            user: "hlq190619",
            phoneNumber: "15500000000",
            password: "111111"
        }
    }

    p_api.innerHTML = "正在注册";
    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_logout() {
    var input = {
        method: "logout",
        params: {
            user: "hlq190619"
        }
    }
    p_api.innerHTML = "正在退出";
    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_reqLiveCategories() {
    var input = {
        method: "reqLiveCategories"
    }

    p_api.innerHTML = "Loading";

    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}


function OMCSDK_reqChannels() {
    var input = {
        method: "reqChannels",
        params: {
            categoryID: "9"
        }
    }

    p_api.innerHTML = "Loading";

    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_reqEPG() {
    var input = {
        method: "reqEPG",
        params: {
            channelID: "13",
            startTime: "20190701000000",
            endTime: "20190701235959"
        }
    }

    p_api.innerHTML = "Loading";

    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_reqColumns() {
    var input = {
        method: "reqColumns"
    }

    p_api.innerHTML = "Loading";

    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_reqPrograms() {
    var input = {
        method: "reqPrograms",
        params: {
            columnID : "ddd15b90ff33ad0b",
            start: "0",
            end: "10",
            sortType : "0"
        }
    }

    p_api.innerHTML = "Loading";

    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_reqEpisodes() {
    var input = {
        method: "reqEpisodes",
        params: {
            assetID : "201906131400101499838037",
            programID : "GCABLE_201906131400101499838037_package",
            providerID : "GCABLE"
        }
    }

    p_api.innerHTML = "Loading";

    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

function OMCSDK_customAPI() {
    var input = {
        path: "ptl_ipvp_vod_vod005"
    }
    p_api.innerHTML = "Loading";
    g_bridge.callHandler(OMC_PORTAL_API, input, function responseCallback(responseData) {
        p_api.innerHTML = JSON.stringify(responseData);
    });
}

// config module
function OMCSDK_setLocation() {
    var input = {
        pLocation: "800000",
        plocation: "400000",
        cus_key1:"2000"
    }
    p_config.innerHTML = "setting";
    g_bridge.callHandler(OMC_PORTAL_CONFIG, input, function responseCallback(responseData) {
        p_config.innerHTML = JSON.stringify(responseData);
    });
}

// player module
function OMCPlayer_getVodURL() {
    p_player.innerHTML = "getting VodURL... 如果显示无此频道，请先点击获取地区以设置地区";
    var columnID = document.getElementById("vod_columnID").value;
    var programID = document.getElementById("vod_programID").value;
    var episodeID = document.getElementById("vod_episodeID").value;

    var input = {
        method: "getURL",
        params: {
            columnID: columnID,
            programID: programID,
            episodeID: episodeID
        }
    }
    g_bridge.callHandler(OMC_PLAYER, input, function responseCallback(responseData) {
        p_player.innerHTML = JSON.stringify(responseData);
        var url = responseData.result;
        if (!url || 0 === url.length) {
            // result 是空
            return;
        }
        // url = "http://www.sumaott.com/live/CCTV4_1000.m3u8?";
        OMCSDK_play(url);
    });
}

function OMCPlayer_getLiveURL() {
    p_player.innerHTML = "getting LiveURL... 如果显示无此频道，请先点击获取地区以设置地区";
    var channelID = document.getElementById("live_channelID").value;
    var startTime = document.getElementById("live_epgStartTime").value;

    var input = {
        method: "getURL",
        params: {
          channelID: channelID,
          playDate: startTime
        }
    }
    g_bridge.callHandler(OMC_PLAYER, input, function responseCallback(responseData) {
        p_player.innerHTML = JSON.stringify(responseData);
        var url = responseData.result;
        if (!url || 0 === url.length) {
            // result 是空
            return;
        }
        // url = "http://flv2.bn.netease.com/videolib3/1611/01/XGqSL5981/SD/XGqSL5981-mobile.mp4";
        // url = "http://www.sumaott.com/live/CCTV4_1000.m3u8?";
        // url = "http://devimages.apple.com/iphone/samples/bipbop/bipbopall.m3u8";
        OMCSDK_play(url);
    });
}

function OMCSDK_play(playUrl) {
    var video = document.getElementById("myPlayer");
    // 设置视图 16:9
    if (video.style.height == 0) {
        video.style.width = video.clientWidth + "px";
        video.style.height = video.clientWidth / (16.0/9.0) + "px";       
    }
    video.src = playUrl;
    if(video.paused){
        video.play();//开始播放
   }else{
        video.pause();//暂停播放
   }   
}


function OMCPlayer_play() {
    p_player.innerHTML = "play live... 如果显示无此频道，请先点击获取地区以设置地区";
    var channelID = document.getElementById("live_channelID").value;
    var startTime = document.getElementById("live_epgStartTime").value;
    
    var input = {
        method: "play",
        params: {
            channelID: channelID,
            playDate: startTime
        }
    }
    g_bridge.callHandler(OMC_PLAYER, input, function responseCallback(responseData) {
        p_player.innerHTML = JSON.stringify(responseData);
    });
}

function OMCPlayer_vodPlay() {
    p_player.innerHTML = "play vod... 如果显示无此频道，请先点击获取地区以设置地区";
    var columnID = document.getElementById("vod_columnID").value;
    var programID = document.getElementById("vod_programID").value;
    var episodeID = document.getElementById("vod_episodeID").value;

    var input = {
        method: "play",
        params: {
            columnID: columnID,
            programID: programID,
            episodeID: episodeID
        }
    }
    g_bridge.callHandler(OMC_PLAYER, input, function responseCallback(responseData) {
        p_player.innerHTML = JSON.stringify(responseData);
    });
}